function MovixLib_FillGridLines(p, lineindex, rowindex)
 local i = 0;
 local w , h ;
 local val = "";
 local line = nil
 local colframe = nil
 local colheight = 0;
 if not p.lines then MovixLib_DrawHeaders(p, true, nil, true) --return 0; end
 end
 if not p.lines[lineindex] then return 0; end
   p.lines[lineindex].parent = p;
   local row = p.data[rowindex]
   line = p.lines[lineindex]
   line.rowindex = rowindex;
   local hlt = getglobal(line:GetName().."HL")
   if p.SelectedRow and p.SelectedRow[row.MovixLibID] then
    p.SelectedRow[row.MovixLibID] = line
    hlt:Show()
   else
    hlt:Hide()
   end
   local j = 0;
   for colid, col in ipairs(p.Headers) do
        j = j + 1;
        colframe = line.cols[j]
        if colframe == nil then tdbg("COLFRAME IS NIL, J = ",j," LineIndex = ",lineindex) end
   -- GET the proper column value
        val = MovixLib_GetTransformedValue(row[col.val], col.valfoo, col.type)

    -- SET CONTENT FOR :        
        local ttype =  type(val)
        -- STRING
        if     col.type == "string" then
            if colframe:GetObjectType() ~= "FontString" then return 0; end
            if ttype == "string" or ttype == "number" or ttype == "nil" then
                colframe:SetText((val or "#NIL#"));
                if ttype == "nil" and col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
            else
                if ttype == "boolean" then
                    if val then                 
                        colframe:SetText("#TYPE-BOOL#true");
                    else
                        colframe:SetText("#TYPE-BOOL#false");
                    end
                elseif ttype == "table" then
                    colframe:SetText("#TYPE-TABLE#");
                else
                    colframe:SetText("#TYPE-?#");
                end
                if col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
            end
            MovixLib_SetFontStringParams(p, row, colframe, col, row[col.colorfooval])
            

        -- NUMBER        
        elseif col.type == "number" then
            if colframe:GetObjectType() ~= "FontString" then return 0; end
            if ttype == col.type then
                colframe:SetText(tostring(tonumber(val)));
            elseif  ttype == "nil" then
                colframe:SetText("#NIL#");
                if col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
            else
                colframe:SetText("#TYPE#");
                if col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
            end
            MovixLib_SetFontStringParams(p, row, colframe, col, row[col.colorfooval])
        -- DATE        
        elseif string.find(col.type, "%%") then
            --if not col.friendlyfoo then col.friendlyfoo = "Movixlib_GetDateFormated" end
            if colframe:GetObjectType() ~= "FontString" then return 0; end
            if ttype == "number" then
                colframe:SetText(Movixlib_GetDateFormated(col.type, tonumber(val)));
            elseif  ttype == "nil" then
                colframe:SetText("#NIL#");
                if col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
            else
                colframe:SetText("#TYPE#");
                if col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
            end
            MovixLib_SetFontStringParams(p, row, colframe, col, row[col.colorfooval])
        -- TEXTURE        
        elseif col.type == "texture" then
            if colframe:GetObjectType() ~= "Texture" then return 0; end
            colframe:Hide()
            colframe:SetTexture("");
            if ttype == "string" then
                if colframe:SetTexture(val) == nil then
                 if val ~= "" then
                  colframe:SetTexture(MovixLib_Grid.EmptyTexture);
                 end
                end
            elseif ttype == "table"then
                colframe:SetTexture(unpack(val));
            elseif  ttype == "nil" then
                colframe:SetTexture(MovixLib_Grid.EmptyTexture);
            else
                colframe:SetTexture(MovixLib_Grid.EmptyTexture);
            end
            colframe:Show()
            MovixLib_SetTextureParams(p, colframe, col, row)
        -- BOOLEAN      
        elseif col.type == "boolean" then
            if colframe:GetObjectType() ~= "CheckButton" then return 0; end
            if ttype == "boolean" then
                colframe:SetChecked(val);
                --colframe:Disable()
                colframe:Show()
            elseif  ttype == "nil" then
                colframe:Hide()
            else
                colframe:Hide()
            end
            if col.clickfoo then
                colframe:SetScript("OnClick", function (self) Movixlib_Grid_ExecuteClickfoo(self) end)
                colframe.val = row[col.val]
                colframe.clickfoo = col.clickfoo
            end
        -- CUSTOM BUTTON
        elseif col.type == "custombutton" then  
            if colframe.ctype ~= "custombutton" then return 0; end
            if ttype == "string" then
                colframe:SetNormalTexture(val)
                colframe:SetPushedTexture(val)
                colframe:SetHighlightTexture(val.."hl")
            elseif  ttype == "nil" then
                colframe:Hide()
            else
                colframe:Hide()
            end
            if col.clickfoo then
                colframe:SetScript("OnClick", function (self) Movixlib_Grid_ExecuteClickfoo(self) end)
                colframe.val = row[col.val]
                colframe.clickfoo = col.clickfoo
            end
            colframe:SetScript("OnEnter", function (self) MovixLib_OnEnterLine(line) if col.tooltip then GEM3UI_GameTooltipShow(self, MovixLib_GetLocale(col.tooltip, p.gridid), true) end end )
            colframe:SetScript("OnLeave", function (self) MovixLib_OnLeaveLine(line) GameTooltip:Hide() end )
        -- BUTTON
        elseif col.type == "button" then  
            if colframe:GetObjectType() ~= "Button" then return 0; end
            if ttype == "string" then
                colframe:SetText(val);
            elseif  ttype == "nil" then
                colframe:SetText("#NIL#");
                if col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
                colframe:Hide()
            else
                colframe:SetText("#TYPE#");
                if col.errorfoo then 
                    colframe:SetText(Movixlib_Grid_ExecuteErrorfoo(col.errorfoo))
                end
            end
            if col.clickfoo then
                colframe:SetScript("OnClick", function (self) Movixlib_Grid_ExecuteClickfoo(self) end)
                colframe.val = row[col.val]
                colframe.clickfoo = col.clickfoo
            end
            colframe:SetScript("OnEnter", function (self) MovixLib_OnEnterLine(line) if col.tooltip then GEM3UI_GameTooltipShow(self, MovixLib_GetLocale(col.tooltip, p.gridid), true) end end )
            colframe:SetScript("OnLeave", function (self) MovixLib_OnLeaveLine(line) GameTooltip:Hide() end )
            MovixLib_SetFontStringParams(p, row, colframe, col, row[col.colorfooval])
        -- CUSTOM
        elseif col.type == "custom" then  
                if col.formfoo then
                        MovixLib_Grid_ExecuteFormFoo(p, row, colframe, col.formfoo)
                end
        -- TABLE
        elseif col.type == "table" then  
            if ttype == "table" then
               --data = row[col.val]
               
               --MovixLib_FillData(data, p.lines[lineindex].cols[j]);
               --MovixLib_RefreshGrid(p.lines[lineindex].cols[j], true)
            elseif  ttype == "nil" then
                --p.lines[lineindex].cols[j]:SetText("#NIL#");
            else
                --p.lines[lineindex].cols[j]:SetText("#TYPE#");
            end
        end
     --end  -- IF COL.VISISBLE = TRUE
    end -- END COL LOOP
    
    -- SET LINE HEIGHT
    line.lineoptions.height = MovixLib_GetLineHeight(p)
    line:SetHeight(line.lineoptions.height)
    
    -- FORMAT CELLS
    MovixLib_FormatRowCells(line)
 --tdbg("FINAL LINE HEIGHT:"..line.lineoptions.height)
 return line.lineoptions.height or 0
 
end

function MovixLib_ScrollFrame_OnScroll(self, arg1)
	local scrollbar = getglobal(self:GetName().."ScrollBar");
	scrollbar:SetValue(arg1);
	self.offset = floor((arg1 / self.parent.ComputedLineHeight) + 0.5);
	MovixLib_ScrollFrame_Update(self);
end

function MovixLib_ScrollFrame_OnMouseWheel(self, value, scrollBar)
	scrollBar = scrollBar or getglobal(self:GetName() .. "ScrollBar");
    --local lh = (self.parent.dataGridHeight/ self.parent.linecount) or self.parent.GridParams.ComputedLineHeight 
    local lh = self.parent.ComputedLineHeight 
	if ( value > 0 ) then
		scrollBar:SetValue(scrollBar:GetValue() - lh);
	else
		scrollBar:SetValue(scrollBar:GetValue() + lh);
	end
end

function MovixLib_ScrollFrame_Update(obj)
   local lineplusoffset=0;
   local root = getglobal(string.sub(obj:GetName(),1,string.len(obj:GetName())-16));
   if #root.Headers == 0 then return end
   if root.rebuild or FauxScrollFrame_GetOffset(obj) > root.rowcount then
    local scrollBar = getglobal(obj:GetName().."ScrollBar")
    scrollBar:SetMinMaxValues(0, 0);
    scrollBar:SetValue(0);
    obj.offset = 0;
    root.rebuild = false
   end
   root.offset = FauxScrollFrame_GetOffset(obj);
   local cnt = root.rowcount;
   local totalheight = 0;
   local virtual_lineheight = 0;
   local linecnt = 0;
   local line = 1
   local lineh = 0
   local l = getglobal(root:GetName().."GridLine"..line);
   while (l) do
       l:Hide();
       line = line + 1
       l = getglobal(root:GetName().."GridLine"..line):Hide();
   end
   line = 0;
   local cont = true
   --tdbg("root.dataGridHeight", root.dataGridHeight, " --- totalheight : ",totalheight)
   while ((root.dataGridHeight > (totalheight + lineh)) and cont) do
     line = line +1;
     lineplusoffset = line + FauxScrollFrame_GetOffset(obj);
     --tdbg("LINEPLUSOFFSET"..lineplusoffset .. " --- CNT : "..cnt.." -- LINE:"..line)
     cont = false
     if lineplusoffset < cnt+1 then
       lineh = MovixLib_FillGridLines(root, line, lineplusoffset)
       if lineh > 0 and root.dataGridHeight > (totalheight+lineh) then
        getglobal(root:GetName().."GridLine"..line):Show();
        totalheight =  totalheight + lineh
        linecnt = linecnt + 1;
        cont = true
       end
     end
   end
   --virtual_lineheight = (root.dataGridHeight/(linecnt))
   --tdbg("ROWCNT")
   virtual_lineheight = (totalheight/(linecnt))
   root.ComputedLineHeight = virtual_lineheight
   --root.linecount = linecnt
   --tdbg("ROWCNT",cnt , " --- LINECNT : ",linecnt,"  -- LineHEIGHT:",virtual_lineheight," ---")
   
   FauxScrollFrame_Update(obj,cnt,linecnt, virtual_lineheight);
end
