﻿function MovixLib_ClickHeader(...)
 local self, button = select(1, ...);
 if button == "LeftButton" then
  if not GridLib.Grids[self.parent.gridid].Headers[self.hid].disablesort or GridLib.Superuser then
    if self.sortorder == nil then
        self.sortorder = 1;
    elseif self.sortorder == 1 then
        self.sortorder = -1;
    else
        self.sortorder = nil
    end
    if self.parent.GridParams.sortcol == nil then
        self.parent.GridParams.sortcol = MovixLib_GetTable()
    end
    for i, sortcol in ipairs(self.parent.GridParams.sortcol) do
        if abs(sortcol) == self.hid or not IsControlKeyDown() then
            table.remove(self.parent.GridParams.sortcol, i)
        end
    end

    if self.sortorder then
        table.insert(self.parent.GridParams.sortcol, self.hid * self.sortorder)
        MovixLib_SortColParent = self.parent
        MovixLib_SortCols = self.parent.GridParams.sortcol
        table.sort(self.parent.data, MovixLib_SortTables);
    else
        self.parent.GridParams.sortcol = nil
        MovixLib_SortColParent = nil
        MovixLib_SortCols = nil
        MovixLib_FillData(self.parent)
    end
    
    MovixLib_RefreshGrid(self.parent);
  end
 elseif button == "RightButton" then 
  MovixLib_HeaderCellMenu(self, GridLib.Grids[self.parent.gridid].Headers[self.hid])
 end
end

function MovixLib_GroupCol(self)
    local p = self.parent
    tdbg("PARENT: ",p:GetName())
    if p.GridParams.GroupCol == self.hid then
     p.GridParams.GroupCol = nil
    else
     p.GridParams.GroupCol = self.hid 
    end
    
    MovixLib_FillData(p)
    MovixLib_RefreshGrid(p, true);
end

function MovixLib_ResetGrid(p, level, refresh)
   local Dgridparam = p.DGridParams
   local gridparam = p.GridParams
   if level == "ALL" then
      local resetfoo = Movixlib_GetGridParam(p.gridid, "resetfoo")
      MovixLib_WipeTable(GridLib.Grids[p.gridid].Headers)
      MovixLib_WipeTable(GridLib.Grids[p.gridid].DHeaders)
      GridLib.Grids[p.gridid].Headers = nil
      GridLib.Grids[p.gridid].DHeaders = nil
      p.Headers = nil
      p.DHeaders = nil
      MovixLib_WipeTable(GridLib.Grids[p.gridid].GridParams)
      if resetfoo then
        local f = loadstring([[
                            return
                            function ()
                                return ]] .. resetfoo .. [[()
                            end
                         ]]
                        )
        local func = f();
        func ()
      end
      refresh = true
   elseif level == "COLS" then
      MovixLib_WipeTable(GridLib.Grids[p.gridid].Headers)
      MovixLib_WipeTable(GridLib.Grids[p.gridid].DHeaders)
      GridLib.Grids[p.gridid].Headers = nil
      GridLib.Grids[p.gridid].DHeaders = nil
      p.Headers = nil
      p.DHeaders = nil
      GridLib.Grids[p.gridid] = MovixLib_GetGridDefaults(p, p.gridid, gridparam.DataSource or Dgridparam.DataSource, gridparam.inherits or Dgridparam.inherits)
      MovixLib_FillData(p)
   elseif level == "GRID" then
      MovixLib_WipeTable(GridLib.Grids[p.gridid].GridParams)
      GridLib.Grids[p.gridid] = MovixLib_GetGridDefaults(p, p.gridid, gridparam.DataSource or Dgridparam.DataSource, gridparam.inherits or Dgridparam.inherits)
      MovixLib_FillData(p)
   elseif level == "FILTERS" then
      for i, col in pairs(p.Headers) do
         if col.filtertbl then
            MovixLib_WipeTable(col.filtertbl)
         end
      end
      MovixLib_FillData(p)
   end
   if refresh ~= false then
      MovixLib_RefreshGrid(p, true);
   else
      MovixLib_RefreshGrid(p, false);
   end
   MovixLib_DDMenuFrame:Hide();
end

function MovixLib_ResetCell(self)
  local p = self.parent;
  local cola = GridLib.Grids[self.parent.gridid].Headers[self.hid]
  local colf = nil
  local colindex = cola.pos
  table.remove(p.Headers, colindex)
  if p.DHeaders ~= nil then
    for i, col in pairs(p.DHeaders) do
        if col.val == cola.val then
            colf = MovixLib_TblCpy(col)
        end 
    end
 else 
    colf = MovixLib_NewCellOptions(cola.val, "")
 end
 MovixLib_SetCellOption(colf, "pos", colindex)
 colf.pos = colindex
 table.insert(p.Headers, colindex, colf)
 MovixLib_RefreshGrid(p, true);
 MovixLib_DDMenuFrame:Hide();
end

function MovixLib_HideCol(lbl)
 local colindex = lbl.hid
 local p = lbl.parent;
 if p.GridParams.sortcol then
  for k, c in ipairs(p.GridParams.sortcol) do
   if c == colindex then
    table.remove(p.GridParams.sortcol, k)
   end
  end
 end
 table.remove(p.Headers, colindex)
 local i = 0;
 for coli, col in pairs(p.Headers) do
  col.pos = coli;
 end
 MovixLib_RefreshGrid(p, true);
 MovixLib_DDMenuFrame:Hide();
end

function MovixLib_AddCol(p, lbl, fname, colparams)
 local colindex = 1
 if lbl then
    colindex = lbl.hid
 end
 local colf = nil;
 local i = 0;

 if colparams then
    colf = colparams
  else
    if p.DHeaders ~= nil then
        for i, col in pairs(p.DHeaders) do
            if col.lbl == fname then
                colf = MovixLib_TblCpy(col)
            end 
        end
    end
  end
 
 

 if colf == nil then
  colf = MovixLib_NewCellOptions(fname, "")
 end
 MovixLib_SetCellOption(colf, "pos", colindex or 1)
 
 table.insert(p.Headers, colindex or 1, colf)

 for coli, col in pairs(p.Headers) do
  i = i +1;
  col.pos = i;
 end
 MovixLib_RefreshGrid(p, true);
 MovixLib_DDMenuFrame:Hide();
end

function MovixLib_SetColType(lbl, coltype)
 MovixLib_DDMenuFrame:Hide();
 local colindex = lbl.hid
 local coltype_to_set = coltype
 local p = lbl.parent;
 local i = 0;
 for coli, col in pairs(p.Headers) do
  i = i +1;
  if i == colindex then
    if coltype == "%default" then
     col.type = coltype
     MovixLib_RefreshGrid(p, true);
     return
    end
    if string.find (coltype, "%%") then
        col.type = MovixLib_ModifyDateString(col.type, coltype)
    else
        col.type = coltype
   end
  end
 end
 MovixLib_RefreshGrid(p, true);
end



function MovixLib_SetColLabel(lbl, lbltxt)
 local colindex = lbl.hid
 local p = lbl.parent;
 local i = 0;
 for coli, col in pairs(p.Headers) do
  i = i +1;
  if i == colindex then
   col.lbl = lbltxt;
  end
 end
 MovixLib_RefreshGrid(p);
end


function MovixLib_justifyCol(lbl, orientation)
 local colindex = lbl.hid
 local p = lbl.parent;
 local i = 0;
 for coli, col in pairs(p.Headers) do
  i = i +1;
  if i == colindex then
   col.justify = orientation;
  end
 end
 MovixLib_RefreshGrid(p);
end

function MovixLib_SetFilter(p, col, value)
 for val, shown in pairs(col.filtertbl) do
  if value == "##none" then
   col.filtertbl[val] = false
  end
  if value == "##all" then
   col.filtertbl[val] = true
  end
  if val == value then
   col.filtertbl[val] = not col.filtertbl[val]
  end
 end
 MovixLib_FillData(p)
 MovixLib_RefreshGrid(p, true, true)
end


function MovixLib_EditStringValue(obj, Oldvalue, OnChangeFoo)
 local EditBoxFrame = getglobal("MovixLib_EditBoxFrame")
 if EditBoxFrame == nil then
  EditBoxFrame = CreateFrame("FRAME", "MovixLib_EditBoxFrame", nil, "MovixLib_EditBoxTemplate");
 end
 local text = getglobal("MovixLib_EditBoxFrameText")
 --EditBoxFrame:SetParent("cursor")
 local x, y = GetCursorPosition();
 x = obj:GetLeft()
 y = obj:GetBottom()
 local factor = obj:GetEffectiveScale() 
 --factor = 1;
 x = x * factor
 y = y * factor
 EditBoxFrame:SetPoint("BOTTOMLEFT", x, y, "BOTTOMLEFT")
 EditBoxFrame:SetFrameStrata("TOOLTIP");
 EditBoxFrame:Raise()
 local w = obj:GetWidth()
 if w < 50 then w = 50 end
 EditBoxFrame:SetWidth(w)
 text:SetAllPoints()
 text:SetScript("OnEnterPressed", function () OnChangeFoo(obj, text:GetText()); EditBoxFrame:Hide(); end)
 text:SetText(Oldvalue)
 EditBoxFrame:Show();
 text:SetFocus()
end

function MovixLib_SetColFontSize(lbl, fontsize)
 local colindex = lbl.hid
 local p = lbl.parent;
 local i = 0;
 for coli, col in pairs(p.Headers) do
  i = i +1;
  if i == colindex then
   if fontsize == "default" then
     col.fontsize = nil;
   else
     col.fontsize = tonumber(fontsize)
   end
  end
 end
 MovixLib_RefreshGrid(p);
end

function MovixLib_SetHeaderFontSize(p, fontsize)
 p.GridParams.LabelFontSize = tonumber(fontsize)
 MovixLib_RefreshGrid(p);
end

function MovixLib_SetValueFontSize (p, fontsize)
 p.GridParams.ValueFontSize = tonumber(fontsize)
 MovixLib_RefreshGrid(p);
end


function MovixLib_SetGridParamsColor(p, param, reset)
 local r, g, b = ColorPickerFrame:GetColorRGB();
 local a = OpacitySliderFrame:GetValue();
 if reset then 
  p.GridParams[param] = nil
 else
  p.GridParams[param] = {r, g, b, a}
 end
 local frame = nil

 if param == "HeaderBGcolor" then
  frame = getglobal(p.HeaderLine:GetName().."HeaderBG");
 elseif param == "GridBGcolor" then
  frame = getglobal(p.HeaderLine:GetName().."GridBG");
 elseif param == "OddLineColor" then
  local i = 1
  while (p.lines[i]) do
   if math.fmod(i, 2) == 0 and p.lines[i].OddEven then
    p.lines[i].OddEven:SetTexture(r,g,b,a)
   end
   i = i +1
  end

 elseif param == "HeaderTextColor" then
   p.HeaderLine.FontObject:SetTextColor(r,g,b,a)
  MovixLib_RefreshGrid(p);
 elseif param == "DefaultTextColor" then
  for i, frame in ipairs(MovixLib_controls.used.string) do
   if frame.parent.parent.gridid == p.gridid then
    if p.Headers[frame.hid].color == nil then
     frame:SetTextColor(r,g,b,a)
    end
   end 
  end
 end
 if frame then
  frame:SetTexture(r,g,b,a);
 end
 if reset then MovixLib_RefreshGrid(p); end
end

function MovixLib_SetColumTextShadowColor (self, col)
 local p = self.parent
 local r, g, b = ColorPickerFrame:GetColorRGB();
 local a = OpacitySliderFrame:GetValue();
 local n = 1;
 while p.lines[n] do
   p.lines[n].cols[col.pos]:SetTextColor(r,g,b,a)
   col.shadowcolor = {r, g, b, a}
   n = n +1;
 end
 MovixLib_RefreshGrid(p)
end

function MovixLib_SetTextureColor(self, col) 
 local p = self.parent
 local r, g, b = ColorPickerFrame:GetColorRGB();
 local a = OpacitySliderFrame:GetValue();
 local n = 1;
 while p.lines[n] do
   p.lines[n].cols[col.pos]:SetVertexColor(r,g,b,a)
   col.texturecolor = {r, g, b, a}
   n = n +1;
 end
 MovixLib_RefreshGrid(p)
end


function MovixLib_SetColumTextColor(self, col)
 local p = self.parent
 local r, g, b = ColorPickerFrame:GetColorRGB();
 local a = OpacitySliderFrame:GetValue();
 local n = 1;
 while p.lines[n] do
   p.lines[n].cols[col.pos]:SetTextColor(r,g,b,a)
   col.color = {r, g, b, a}
   n = n +1;
 end
 MovixLib_RefreshGrid(p)
end

function MovixLib_GetColorFooName(colorfoo)
  local name = "Unknown name"
  if colorfoo then
    local foo = loadstring([[
                            return
                            function (val, CMD)
                                return ]] .. colorfoo .. [[(val, CMD)
                            end
                         ]]
                        )
    func = foo();
    name = func(nil, "GET_NAME")
  end
  return name
end
