﻿-- Context menu gridheader
function MovixLib_HeaderCellMenu(self)
-- tdbg("COLMENU")
    GameTooltip:Hide()
    local col = GridLib.Grids[self.parent.gridid].Headers[self.hid]
    local GridParams = GridLib.Grids[self.parent.gridid].GridParams
    MovixLib_DDTable = MovixLib_ReleaseTable(MovixLib_DDTable, 10);
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("COLUMN").." "..(col.lbl or ""), isTitle = true, textHeight = 15 })
    MovixLib_DDMenuAddLine({text = " ", disabled = true})
    MovixLib_ColumnMenu(self)
    MovixLib_DDMenuAddLine({text = " ", disabled = true})
    MovixLib_GetGridMenu(self.parent, self)    
    MovixLib_DDMenuAddLine({text = " ", disabled = true})
    if not GridParams.disableAdvancedCFG or GridLib.SuperUser then 
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Advanced Grid Config") , 
                            func = function ()  MovixLib_Grid_OptionsFrame:Hide()
                                                MovixLib_Grid_OptionsFrame:SetParent(self.parent)
                                                MovixLib_Grid_OptionsFrame.gridid = self.parent.gridid
                                                MovixLib_Grid_OptionsFrame:Show() 
                                   end}
                          )
    end
    MovixLib_SetDDMenu(self)
end

function MovixLib_GridMenu(self)
    --tdbg("GRIDMENUCALL")
    MovixLib_DDTable = MovixLib_ReleaseTable(MovixLib_DDTable, 10);
    MovixLib_GetGridMenu(self)    
    MovixLib_SetDDMenu()
end


function MovixLib_ColumnMenu(self)
    local col = GridLib.Grids[self.parent.gridid].Headers[self.hid]
    local p = self.parent
    
--- MAIN MENU LEVEL

    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Column Format"), isTitle = true, textHeight = 14 })
    if not col.disablehedit or GridLib.SuperUser then
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Column Header label") , func = function () MovixLib_EditStringValue(self, (col.lbl or ""), MovixLib_SetColLabel) end})   
    end
    if not col.disabledatatype or GridLib.SuperUser then
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Data Type"), hasArrow = true, value = "CT"})
        -- FORMATS
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("String") , isRadio = true, checked = (col.type=="string"), func = function() MovixLib_SetColType(self, "string")  end}, "CT")
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Number") , isRadio = true, checked = (col.type=="number"), func = function() MovixLib_SetColType(self, "number")  end}, "CT")
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Boolean") , isRadio = true, checked = (col.type=="boolean"), func = function() MovixLib_SetColType(self, "boolean")  end}, "CT")
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Texture") , isRadio = true, checked = (col.type=="texture"), func = function() MovixLib_SetColType(self, "texture")  end}, "CT")
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Button") , isRadio = true, checked = (col.type=="button"), func = function() MovixLib_SetColType(self, "button")  end}, "CT")
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Frame") , isRadio = true, checked = (col.type=="frame"), func = function() MovixLib_SetColType(self, "frame")  end}, "CT")
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Date & Time") , isRadio = true, checked = string.find(col.type, "%", 1, true), hasArrow = true, func = function() MovixLib_SetColType(self, "%default")  end, value = "TF"}, "CT")
    end
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Justify") ,hasArrow = true, value = "CJ"})
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Font") ,hasArrow = true, value = "CF"})
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Colors") ,hasArrow = true, value = "CC"})
    if not col.disablecolreset or GridLib.SuperUser then
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Reset column"), func = function () MovixLib_ResetCell(self); end})
    end
    MovixLib_DDMenuAddLine({text = " ", disabled = true})
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Column Data"), isTitle = true, textHeight = 14 })
    if not col.disablecoldelete or GridLib.SuperUser then
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Hide column"), func = function () MovixLib_HideCol(self); end})
    end
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Sizes"), hasArrow = true, value = "CD"})
    if not col.disablefilter or GridLib.SuperUser then
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Filters"), hasArrow = true, value = "CQ"})
    --MovixLib_DDMenuAddLine({text = "Group", func = function () MovixLib_GroupCol(self); end})
        -- FILTER SUBMENU
        if not col.filtertbl then
            col.filtertbl = MovixLib_GetTable()
        end
        local filtertbl  = col.filtertbl 
        local allshown = true;
        local noneshown = true;

        for i, row in ipairs(self.parent.data) do
            local col = self.parent.Headers[self.hid]
            local filtertext = MovixLib_GetFilterText(col, row[col.val])
            if filtertbl[filtertext] == nil then
                filtertbl[filtertext] = true
            end
        end
    -- set none all flags
        for value, shown in pairs(filtertbl) do
            if shown == true then 
                noneshown = false
            else
                allshown = false
            end
        end
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("None"), checked = noneshown, func = function () MovixLib_SetFilter(p, col, "##none"); end }, "CQ")
        for value, shown in pairs(filtertbl) do
            MovixLib_DDMenuAddLine({text = value, checked = shown, func = function () MovixLib_SetFilter(p, col, value); end }, "CQ")
        end
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("All"), checked = allshown, func = function () MovixLib_SetFilter(p, col, "##all"); end }, "CQ")
    end
    -- COLORS
    local color = {1,1,1,1}
    if col.color then 
     if type (col.color) ~= "string" then
      color = col.color
     end
    end
    r, g, b, a = unpack (color)
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Color Picker"), isTitle = true, textHeight = 14 }, "CC")
    if col.type == "button" or col.type == "string" or col.type == "number" or string.find(col.type, "%", 1, true) then
     MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Text Color") , notClickable= 1,  r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, swatchFunc = function() MovixLib_SetColumTextColor(self, col)end, opacityFunc = function() MovixLib_SetColumTextColor(self, col)end}, "CC")
     MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Text Shadow Color") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, swatchFunc = function() MovixLib_SetColumTextColor(self, col)end, opacityFunc = function() MovixLib_SetColumTextShadowColor(self, col)end}, "CC")
    end
    if col.type == "texture" then
     r, g, b, a = unpack (col.texturecolor or {1,1,1,1})
     MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Texture Color") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, swatchFunc = function() MovixLib_SetTextureColor(self, col) end}, "CC" )
    end

    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Predefined Colors"), isTitle = true, textHeight = 14 }, "CC")
    local fcolor = Movixlib_GetGridParam(p.gridid, "Colors")
    if fcolor then
     for colname, colorfoo in pairs (fcolor) do
      MovixLib_DDMenuAddLine({text = MovixLib_GetLocale(colname, p.gridid), isRadio = true, checked = col.colorfoo==colorfoo.foo, tooltipTitle=colname, tooltipText=(colorfoo.tooltip or "no tooltip") , func = function() col.colorfoo = colorfoo.foo; col.colorfooval = colorfoo.colval; MovixLib_RefreshGrid(p) MovixLib_DDMenuFrame:Hide(); end  }, "CC" )
     end
    end
    MovixLib_DDMenuAddLine({text = " ", disabled = true}, "CC")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Grid Default"), func = function() col.texturecolor=nil col.colorfoo = nil col.colorfooval = nil col.color = nil MovixLib_RefreshGrid(p) MovixLib_DDMenuFrame:Hide(); end}, "CC" )
    
    -- font
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Font settings"), isTitle = true, textHeight = 14 }, "CF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Font").." "..(col.font or "n/a") , disabled=true, func = function () MovixLib_EditStringValue(self, (col.lbl or ""), MovixLib_SetColLabel) end}, "CF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Size").." "..(col.fontsize or "default") , isRadio = true,
                            func = function () MovixLib_EditStringValue(self, (col.fontsize or "default"), MovixLib_SetColFontSize) end}, "CF")
    
    
    -- Size
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Width"), isTitle = true, textHeight = 14 }, "CD")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Minimal Width").." "..(col.valminw or "n/a") , isRadio = true, func = function() MovixLib_SetColDataSize("valminw", self)  end}, "CD")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Maximal Width").." "..(col.valmaxw or "n/a") , isRadio = true, func = function() MovixLib_SetColDataSize("valmaxw", self)  end}, "CD")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Fixed Width").. "..(col.valw or "n/a") , isRadio = true, func = function() MovixLib_SetColDataSize("valw", self)  end}, "CD")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Height"), isTitle = true, textHeight = 14 }, "CD")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Minimal Height").." "..(col.valminh or "n/a") , isRadio = true, func = function() MovixLib_SetColDataSize("valminh", self)  end}, "CD")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Maximal Height").." "..(col.valmaxh or "n/a") , isRadio = true, func = function() MovixLib_SetColDataSize("valmaxh", self)  end}, "CD")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Fixed Height").. "..(col.valh or "n/a") , isRadio = true, func = function() MovixLib_SetColDataSize("valh", self)  end}, "CD")
    
    
    -- JUSTIFY
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Left"), isRadio = true, checked = (col.justify=="LEFT"), func = function () MovixLib_justifyCol(self, "LEFT"); end}, "CJ")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Center"), isRadio = true, checked = (col.justify=="CENTER"), func = function () MovixLib_justifyCol(self, "CENTER"); end}, "CJ")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Right"), isRadio = true, checked = (col.justify=="RIGHT"), func = function () MovixLib_justifyCol(self, "RIGHT"); end}, "CJ")
    

    
    -- Date Type submenu    
    local sep = GridLib.DateSeperator
    local dtype = nil
    if col.type == "%default" then 
        dtype = MovixLib_DefaultDateStrings
    else
        dtype = col.type
    end
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Day") , isTitle = true, textHeight = 14 }, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Weekday short") , isRadio = true, checked = string.find(dtype, "%wday", 1, true), func = function() MovixLib_SetColType(self, "%wday")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Weekday long") , isRadio = true, checked = string.find(dtype, "%A", 1, true), func = function() MovixLib_SetColType(self, "%A")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Day") , isRadio = true, checked = string.find(dtype, "%d", 1, true), func = function() MovixLib_SetColType(self, "%d")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Month") , isTitle = true, textHeight = 14 }, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Month") , isRadio = true, checked = string.find(dtype, "%m", 1, true), func = function() MovixLib_SetColType(self, "%m")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Monthshort") , isRadio = true, checked = string.find(dtype, "%smo", 1, true), func = function() MovixLib_SetColType(self, "%smo")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Monthlong") , isRadio = true, checked = string.find(dtype, "%lmonth", 1, true), func = function() MovixLib_SetColType(self, "%lmonth")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Year") , isTitle = true, textHeight = 14 }, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Year") , isRadio = true, checked = string.find(dtype, "%y", 1, true), func = function() MovixLib_SetColType(self, "%y")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Year long") , isRadio = true, checked = string.find(dtype, "%Y", 1, true), func = function() MovixLib_SetColType(self, "%Y")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Time") , isTitle = true, textHeight = 14 }, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Hour 12") , isRadio = true, checked = string.find(dtype, "%I", 1, true), func = function() MovixLib_SetColType(self, "%I")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Hour 24") , isRadio = true, checked = string.find(dtype, "%H", 1, true), func = function() MovixLib_SetColType(self, "%H")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Minute") , isRadio = true, checked = string.find(dtype, "%M", 1, true), func = function() MovixLib_SetColType(self, "%M")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Second") , isRadio = true, checked = string.find(dtype, "%S", 1, true), func = function() MovixLib_SetColType(self, "%S")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Special days") , isTitle = true, textHeight = 14 }, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Today") , isRadio = true, checked = string.find(dtype, "%ReplToday", 1, true), func = function() MovixLib_SetColType(self, "%ReplToday")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Tomorrow") , isRadio = true, checked = string.find(dtype, "%ReplTomorrow", 1, true), func = function() MovixLib_SetColType(self, "%ReplTomorrow")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Yesterday") , isRadio = true, checked = string.find(dtype, "%ReplYesterday", 1, true), func = function() MovixLib_SetColType(self, "%ReplYesterday")  end}, "TF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Upcoming week") , isRadio = true, checked = string.find(dtype, "%ReplWeek", 1, true), func = function() MovixLib_SetColType(self, "%ReplWeek")  end}, "TF")
    
end


function MovixLib_GetGridMenu(self, ccol)    
    local GridParams = GridLib.Grids[self.gridid].GridParams
    --local p = self.parent
--- MAIN MENU LEVEL
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Grid options"), isTitle = true, textHeight = 14 })
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Show / Hide") , hasArrow = true, value = "GSH"})
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Headers") , func = function () MovixLib_SetColLabel() end}, "GSH")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("H Slider") , func = function () MovixLib_SetColLabel() end}, "GSH")
    --MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("V Slider") , func = function () MovixLib_SetColLabel() end}, "GSH")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Grid Fonts") , hasArrow = true, value = "GF"})
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Header fontsize").." "..Movixlib_GetGridParam(self.gridid, "LabelFontSize") , func = function () MovixLib_EditStringValue(self, Movixlib_GetGridParam(self.gridid, "LabelFontSize"), MovixLib_SetHeaderFontSize) end}, "GF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Default fontsize").." "..Movixlib_GetGridParam(self.gridid, "ValueFontSize") , func = function () MovixLib_EditStringValue(self, Movixlib_GetGridParam(self.gridid, "ValueFontSize"), MovixLib_SetValueFontSize) end}, "GF")
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Colors") , hasArrow = true, value = "GSC"})
    if not GridParams.disableAddCol or GridLib.SuperUser then
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Add Columns") , hasArrow = true, value = "AC"})
        if self.data then
        --    MovixLib_DDMenuAddLine({text = "Add Columns Admin" , hasArrow = true, value = "ACADM"})
        end
        -- Column list SUBMENU for Adding Culumns
        for i, col in pairs(self.DHeaders) do
            local l, t = MovixLib_BuildColumnHeaderTooltip(self.gridid, (col.lbl or ""), col.tooltip)
            MovixLib_DDMenuAddLine({text = (l or "") , tooltipTitle=l, tooltipText=t, func = function() MovixLib_AddCol(self, ccol, (col.lbl or "")) end}, "AC")
        end
        if i == 0 then
            MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("NO DATA")}, "ACADM")
        end
    end
    if not GridParams.disableResets or GridLib.SuperUser then
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Resets"), hasArrow = true, value = "GR"})
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Reset Filters"), func = function () MovixLib_ResetGrid(self, "FILTERS", true); end}, "GR")           
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Reset Columns"), func = function () MovixLib_ResetGrid(self, "COLS", true); end}, "GR")           
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Reset Grid"), func = function () MovixLib_ResetGrid(self, "GRID", true ); end}, "GR")           
        MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Reset All"), func = function () MovixLib_ResetGrid(self, "ALL", true ); end}, "GR")           
    end
-- GRID SETTINGS SUBMENU
    r, g, b, a = unpack (Movixlib_GetGridParam(self.gridid, "GridBGcolor"))
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Background") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, tooltipTitle=self.gridid, tooltipText="Click to reset to default color or click the color to change", func = function() MovixLib_SetGridParamsColor(self, "GridBGcolor", true)end, swatchFunc = function() MovixLib_SetGridParamsColor(self, "GridBGcolor")end, opacityFunc = function() MovixLib_SetGridParamsColor(self, "GridBGcolor")end}, "GSC" )
    r, g, b, a = unpack (Movixlib_GetGridParam(self.gridid, "HeaderBGcolor"))
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Header Background") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, tooltipTitle=self.gridid, tooltipText="Click to reset to default color or click the color to change", func = function() MovixLib_SetGridParamsColor(self, "HeaderBGcolor", true)end, swatchFunc = function() MovixLib_SetGridParamsColor(self, "HeaderBGcolor")end, opacityFunc = function() MovixLib_SetGridParamsColor(self, "HeaderBGcolor")end}, "GSC" )
    r, g, b, a = unpack (Movixlib_GetGridParam(self.gridid, "HeaderTextColor"))
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Header Text") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, tooltipTitle=self.gridid, tooltipText="Click to reset to default color or click the color to change", func = function() MovixLib_SetGridParamsColor(self, "HeaderTextColor", true)end, swatchFunc = function() MovixLib_SetGridParamsColor(self, "HeaderTextColor")end, opacityFunc = function() MovixLib_SetGridParamsColor(self, "HeaderTextColor")end}, "GSC" )
    r, g, b, a = unpack (Movixlib_GetGridParam(self.gridid, "OddLineColor"))
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Odd Lines") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, tooltipTitle=self.gridid, tooltipText="Click to reset to default color or click the color to change", func = function() MovixLib_SetGridParamsColor(self, "OddLineColor", true)end, swatchFunc = function() MovixLib_SetGridParamsColor(self, "OddLineColor")end, opacityFunc = function() MovixLib_SetGridParamsColor(self, "OddLineColor")end}, "GSC" )
    r, g, b, a = unpack (Movixlib_GetGridParam(self.gridid, "DefaultTextColor"))
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Text Values") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, tooltipTitle=self.gridid, tooltipText="Click to reset to default color or click the color to change", func = function() MovixLib_SetGridParamsColor(self, "DefaultTextColor", true)end, swatchFunc = function() MovixLib_SetGridParamsColor(self, "DefaultTextColor")end, opacityFunc = function() MovixLib_SetGridParamsColor(self, "DefaultTextColor")end}, "GSC" )
    r, g, b, a = unpack (Movixlib_GetGridParam(self.gridid, "DefaultTextureColor"))
    MovixLib_DDMenuAddLine({text = MovixLib_GetLocale("Textures") , r = r, g=g, b=b, opacity=a, hasColorSwatch = true, hasOpacity= true, tooltipTitle=self.gridid, tooltipText="Click to reset to default color or click the color to change", func = function() MovixLib_SetGridParamsColor(self, "DefaultTextureColor", true)end, swatchFunc = function() MovixLib_SetGridParamsColor(self, "DefaultTextureColor")end, opacityFunc = function() MovixLib_SetGridParamsColor(self, "DefaultTextureColor")end}, "GSC" )
    

end

function MovixLib_GridListsContextMenu(data, foo)
    MovixLib_DDTable = MovixLib_ReleaseTable(MovixLib_DDTable, 10);
    MovixLib_DDMenuAddLine({text = data, isTitle = true, textHeight = 15 })
    MovixLib_DDMenuAddLine({text = "Delete" , tooltipTitle="Delete", tooltipText=data, func = function() foo(data) end})
    MovixLib_SetDDMenu(self)
end

