﻿function mycolsort(c1,c2)
   return (c1.pos < c2.pos); 
end


function MovixLib_SortTables (L1, L2)
 if MovixLib_SortCols == nil then return; end
 local sortcol_name ;
 local sortcol_order = MovixLib_GetTable();
 local issortcol = MovixLib_GetTable();
 --local col = {}
 --col.val = "MovixLibSelected"
 --table.insert(sortcol_order, col)

 for i, sortcol in ipairs(MovixLib_SortCols) do
    if sortcol < 0 then
        MovixLib_SortColParent.Headers[abs(sortcol)].sortorder = false
    else
        MovixLib_SortColParent.Headers[abs(sortcol)].sortorder = true
    end
    table.insert(sortcol_order, MovixLib_SortColParent.Headers[abs(sortcol)])
    issortcol[abs(sortcol)] = true
 end
 
 for ind, col in pairs(MovixLib_SortColParent.Headers) do
  if not issortcol[col.pos] then
    table.insert(sortcol_order, col)
  end
 end 
 
 local result = MovixLib_CompareTablelines(L1, L2, sortcol_order, 1)
 MovixLib_ReleaseTable(sortcol_order)
 return result
end

function MovixLib_CompareTablelines(L1, L2, sortcol_order, sortcol_index)
 if sortcol_order[sortcol_index] == nil then
--  if MovixLib_SortColOrder then
   return (L1.MovixLibID > L2.MovixLibID)
  --else
   --return (L1.MovixLibID < L2.MovixLibID)
  --end
 end
 local MovixLib_SortColOrder = sortcol_order[sortcol_index].sortorder

 if sortcol_order[sortcol_index].sortvalfoo then
  L1VAL = MovixLib_GetSortingValue(L1[sortcol_order[sortcol_index].val],sortcol_order[sortcol_index].sortvalfoo)
  L2VAL = MovixLib_GetSortingValue(L2[sortcol_order[sortcol_index].val],sortcol_order[sortcol_index].sortvalfoo)
 else
  L1VAL = L1[sortcol_order[sortcol_index].val]
  L2VAL = L2[sortcol_order[sortcol_index].val]
 end
 
 if type (L1VAL) == "string" and sortcol_order[sortcol_index].type == "string" then 
  L1VAL = string.lower(L1VAL)
 end
 if type (L2VAL) == "string" and  sortcol_order[sortcol_index].type == "string" then 
  L2VAL = string.lower(L2VAL)
 end

 -- if type of values to compare not equal
 if type (L1VAL) ~= type (L2VAL) then
  if type (L1VAL) == 'nil' then return false end
  if type (L2VAL) == 'nil' then return true end
  if MovixLib_SortColOrder then
    return type (L1VAL) < type (L2VAL)
  else
    return type (L1VAL) > type (L2VAL)
  end
 end

 -- if type is table
 if type (L1VAL) == "table" then
    if MovixLib_SortColOrder then
        return (#L1VAL > #L2VAL)
    else
        return (#L1VAL < #L2VAL)
    end
 end

 -- if type is nil 
 if L1VAL == nil then
  if MovixLib_SortColOrder then
   return (L1.MovixLibID > L2.MovixLibID)
  else
   return (L1.MovixLibID < L2.MovixLibID)
  end
 end
 
 -- if type is boolean
 if type (L1VAL) == "boolean" then
    if L1VAL ~= L2VAL then
        if MovixLib_SortColOrder then
            return L1VAL
        else
            return L2VAL
        end
    else
        return MovixLib_CompareTablelines(L1, L2, sortcol_order, sortcol_index+1)
    end
 else
    if L1VAL < L2VAL then
        return (not MovixLib_SortColOrder);
    elseif L1VAL > L2VAL then
        return (MovixLib_SortColOrder);
    else
        return MovixLib_CompareTablelines(L1, L2, sortcol_order, sortcol_index+1)
    end
 end
end