local bor = bit.bor
local band = bit.band
local tinsert = table.insert
local tremove= table.remove
local tsort= table.sort

MovixLib_Controls  = {};
MovixLib_Controls.used = {
 ["controls"] = {},
 ["frame"] = {},
 ["custom"] = {},
 ["grid"] = {},
 ["string"] = {},
 ["texture"] = {},
 ["boolean"] = {},
 ["button"] = {},
 ["custombutton"] = {},
 ["slider"] = {},
 ["colorpicker"] = {},
 }

MovixLib_Controls.free = {
 ["controls"] = {},
 ["frame"] = {},
 ["custom"] = {},
 ["grid"] = {},
 ["string"] = {},
 ["texture"] = {},
 ["boolean"] = {},
 ["button"] = {},
 ["custombutton"] = {},
 ["slider"] = {},
 ["colorpicker"] = {},
}

function MovixLib_OpenColorPicker(self)
    OpenColorPicker(self.info)
end



function MovixLib_SetControlPosition(control, parent, previous, orientation, height, width)

end

-- Params ...
-- frame : height, width,  bdColor = {r,g,b,a}, bColor = {r,g,b,a}
-- grid : name, height, width, data, coldefs
-- string : text
-- texture : texture
-- button : text
-- editbox : text
-- datepicker : date
-- timeedit : time
-- slider : name, mintext, maxtext,minValue, maxValue, step, value
-- colorpicker : r, g, b, a
function MovixLib_GetControlObject(parent, ctype, tooltip, OnAction, ...)
    
    parent = MovixLib_LocateFrame(parent)

    --parent = getglobal(parent)
    local control = nil;
    if #MovixLib_Controls.free[ctype] > 0 then
        control = MovixLib_Controls.free[ctype][1]
        tremove(MovixLib_Controls.free[ctype], 1)
    end
    --if not control then
        if ctype == "frame" then
            if not control then
                local cname = "MovixLib_FrameControl"..(#MovixLib_Controls.used[ctype] + 1)
                if getglobal(cname) then
                 tdbg("CONTROL :", cname, " ALREADY EXISTS")
                end
                control = CreateFrame("Frame", cname, parent); 
            end
            --control:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                    --edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                    --tile = true, tileSize = 16, edgeSize = 16, 
                    --insets = { left = 4, right = 4, top = 4, bottom = 4 }});
            control:SetBackdrop({bgFile = "", 
                    edgeFile = "", 
                    tile = true, tileSize = 16, edgeSize = 0, 
                    insets = { left = 0, right = 0, top = 0, bottom = 0 }});
            control:SetClampedToScreen(true)
                        local height, width,  bdColor, bColor = select(1, ...)
            if not bdColor then bdColor = {0,0,0,0.7} end
            if not bColor then bColor = {1,1,1,0.9} end
            if not width then width = parent:GetWidth() end
            if not height then height = parent:GetHeight() end
            control:SetWidth(width)
            control:SetHeight(height)
            control:SetBackdropColor(unpack(bdColor))
            control:SetBackdropBorderColor(unpack(bColor))
            control:SetClampedToScreen(false)
            --control:SetAllPoints()
        elseif ctype == "custom" then
            local formfoo = select(1, ...)
            if not control then
                local cname = "MovixLib_CustomControl"..(#MovixLib_Controls.used[ctype] + 1)
                if getglobal(cname) then
                 tdbg("CONTROL :", cname, " ALREADY EXISTS")
                end
                control = CreateFrame("Frame", cname, parent); 
            end
            control:SetBackdrop({bgFile = "", 
                    edgeFile = "", 
                    tile = true, tileSize = 16, edgeSize = 0, 
                    insets = { left = 0, right = 0, top = 0, bottom = 0 }});
            control:SetClampedToScreen(false)
            if not width then width = parent:GetWidth() end
            if not height then height = parent:GetHeight() end
            control:SetWidth(width)
            control:SetHeight(height)
            if formfoo then
             MovixLib_Grid_ExecuteFormFoo(nil, nil, control, formfoo, "create", scale)
            end
            control.formfoo = formfoo
        elseif ctype == "grid" then
            local name, height, width, data, coldefs = select (1, ...)
            if not control then
                control = MovixLib_GetControlObject(parent:GetName(), "frame", nil, nil, height, width)
            end
            if not width then width = parent:GetWidth() end
            if not height then height = parent:GetHeight() end
            control:SetWidth(width)
            control:SetHeight(height)
            MovixLib_GetGridDefaults(control, name, data)
            function control:refresh()
                MovixLib_FillData(self);
                MovixLib_RefreshGrid(self, true)
            end
            --MovixLib_FillData(control);
            --MovixLib_RefreshGrid(self)
            control:refresh()
        elseif ctype == "string" then
            if not control then
                local cname = "MovixLib_stringControl"..(#MovixLib_Controls.used[ctype] + 1)
                if getglobal(cname) then
                 tdbg("CONTROL :", cname, " ALREADY EXISTS")
                end
                control = parent:CreateFontString(cname, "OVERLAY", "GameFontNormal"); 
            end
            control:SetText("")
            control:SetTextColor(1,1,1,1)
            control:SetJustifyH("LEFT")
            control:SetJustifyV("MIDDLE")
        elseif ctype == "texture" then
            if not control then
                local cname = "MovixLib_TextureControl"..(#MovixLib_Controls.used[ctype] + 1)
                if getglobal(cname) then
                 tdbg("CONTROL :", cname, " ALREADY EXISTS")
                end
                control = parent:CreateTexture(cname, "OVERLAY" ); 
            end
            control:SetTexCoord(0,1,0,1)
            control:SetTexture("")
            control:SetVertexColor(1,1,1,1)
        elseif ctype == "boolean" then
            if not control then
                local cname = "MovixLib_toggleControl"..(#MovixLib_Controls.used[ctype] + 1)
                if getglobal(cname) then
                 tdbg("CONTROL :", cname, " ALREADY EXISTS")
                end
                control = CreateFrame("CHECKBUTTON", cname, parent, "MovixLib_CheckButtonTemplate");
            end
            control:SetScript("OnClick", OnAction)	
            control:SetScript("OnEnter", MovixLib_generic_OnEnter)
	        control:SetScript("OnLeave", MovixLib_generic_OnLeave)
        elseif ctype == "button" then
            if not control then
                local cname = "MovixLib_ButtonControl"..(#MovixLib_Controls.used[ctype] + 1)
                if getglobal(cname) then
                 tdbg("CONTROL :", cname, " ALREADY EXISTS")
                end
                control = CreateFrame("BUTTON", cname, parent, "UIPanelButtonTemplate");
            end
            --control = CreateFrame("BUTTON", "MovixLib_ButtonControl"..(#MovixLib_Controls.used[ctype] + 1), parent, "MovixLib_lineTemplate" );
            control:SetScript("OnClick", OnAction)	
            control:SetScript("OnEnter", MovixLib_generic_OnEnter)
	        control:SetScript("OnLeave", MovixLib_generic_OnLeave)
            control:SetText("")
        elseif ctype == "custombutton" then            
            if not control then
                local cname = "MovixLib_CustomButtonControl"..(#MovixLib_Controls.used[ctype] + 1)
                if getglobal(cname) then
                 tdbg("CONTROL :", cname, " ALREADY EXISTS")
                end
                control = CreateFrame("BUTTON", cname, parent);
            end
            --control = CreateFrame("BUTTON", "MovixLib_ButtonControl"..(#MovixLib_Controls.used[ctype] + 1), parent, "MovixLib_lineTemplate" );
            control:SetScript("OnClick", OnAction)	
            control:SetScript("OnEnter", MovixLib_generic_OnEnter)
	        control:SetScript("OnLeave", MovixLib_generic_OnLeave)
            control:SetText("")
            control:SetNormalTexture("Interface\\Buttons\\UI-Panel-Button-Up")
            control:SetPushedTexture("Interface\\Buttons\\UI-Panel-Button-Down")
            control:SetHighlightTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
            control:SetDisabledTexture("Interface\\Buttons\\UI-Panel-Button-Disabled")
        elseif ctype == "editbox" then
        elseif ctype == "datepicker" then
        elseif ctype == "timeedit" then
        elseif ctype == "slider" then
        elseif ctype == "slider" then
            if not control then
                control = CreateFrame("Slider", "MovixLib_SliderControl"..(#MovixLib_Controls.used[ctype] + 1), parent, "OptionsSliderTemplate")
            end
            local name, mintext, maxtext,minValue, maxValue, step, value = select(1,...)
        	getglobal(control:GetName() .. "Text"):SetText(name)
		    getglobal(control:GetName() .. "Text"):SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
		    getglobal(control:GetName() .. "Low"):SetText(minText)
		    getglobal(control:GetName() .. "Low"):SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
		    getglobal(control:GetName() .. "High"):SetText(maxText)
		    getglobal(control:GetName() .. "High"):SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b)
		    local currentText = control:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
		    currentText:SetPoint("TOP", control, "CENTER", 0, -8)
			currentText:SetText("???")
    		control:SetMinMaxValues(minValue, maxValue)
		    control:SetValueStep(step)
		    control:SetValue(value)
		    control:SetScript("OnValueChanged", OnAction)
        elseif ctype == "colorpicker" then
            if not control then
                control = parent:CreateTexture( "MovixLib_ColorPickerControl"..(#MovixLib_Controls.used[ctype] + 1), "OVERLAY")
            end
            control:SetScript("OnClick", MovixLib_OpenColorPicker)
            local r, g, b, a = select(1,...)
            control.info = {
			    swatchFunc = OnAction ,
			    opacityFunc = OnAction,
			    r = r,
			    g = g,
			    b = b,
			    opacity = a,
		    }
            control:SetScript("OnClick", MovixLib_OpenColorPicker)
            control:SetScript("OnEnter", MovixLib_generic_OnEnter)
	        control:SetScript("OnLeave", MovixLib_generic_OnLeave)
        end
    --end
    --[[if parent.ctype then
        if not parent.controls then
            parent.controls = {}
        end
        tinsert(parent.controls, control)
    end]]--
    tinsert(MovixLib_Controls.used[ctype], control)
    control.ctype = ctype
    control.tooltipText = tooltip or ""
    control.parent = parent;
    control:SetParent(parent)
    control:Show();
    --tdbg(" CTYPE ", ctype, " NAME ", control:GetName())
    return control;
end

function RCC ()
 MovixLib_ChatMessage("RELEASE ",MLROcnt, " GET ", MLROcnt)

end

function MovixLib_ReleaseControlObject(ctrl)
 local control = MovixLib_LocateFrame(ctrl)
 if control == nil then return; end
 local ctype = control.ctype;
 if not MovixLib_Controls.used[control.ctype] then
    tdbg("CONTROL NAME : ", control:GetName(), "  -  CTYPE ", ctype)
    return
 end
 for ind, c in ipairs(MovixLib_Controls.used[control.ctype]) do
   --if c:GetName() == control:GetName() then
   if c == control then
    if c.formfoo then
       MovixLib_Grid_ExecuteFormFoo(nil, nil, c, c.formfoo, "release", scale)
    end
    c:ClearAllPoints()
    tremove(MovixLib_Controls.used[control.ctype], ind)
    tinsert(MovixLib_Controls.free[control.ctype], c)
    c:Hide()
   end
 end
end



local function MovixLib_generic_OnEnter(self)
  if self.tooltipText ~= nil and type(self.tooltipText) == "string" then
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT")
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, 1)
  end
  GameTooltip:Show()
end

local function MovixLib_generic_OnLeave(self)
	GameTooltip:Hide()
end

function MovixLib_LocateFrame(frame)
   local f
   --tdbg("FRAMETYPE:", type(frame))
   if type(frame) == "string" then
    return getglobal(frame)
   end
   
   if frame ~= nil then
    return frame
   end
   
   return UIParent
end


-- UI Frames

MovixLib_UIFrames = {}
MovixLib_UIFrames.Frames = {}
MovixLib_UIFrames.Titlefont = CreateFont("MovixLib_UIFrameTitlefont")
local tf = MovixLib_UIFrames.Titlefont
local font = "Fonts\\FRIZQT__.TTF"
tf:SetFont(font, 8)
tf:SetShadowOffset(1,1)
tf:SetShadowColor(0,0,0,0.7)
tf:SetTextColor(1,1,1,1)
tf:SetJustifyH("LEFT")
tf:SetJustifyV("MIDDLE")
MovixLib_UIFrames.TitleHeight = 15

function MovixLib_UIFrames.Get(name)
 if type(name) == "string" then
    for _, f in ipairs(MovixLib_UIFrames.Frames) do
        if f.options.name == name then
            return f
        end
    end
 else
    return name
 end
end

function MovixLib_UIFrames.Createsimple(parent, name, width, height, pos_left, pos_top, delimeters)
   local p = MovixLib_LocateFrame(parent)
   local f  = MovixLib_GetControlObject(p, "frame", name, width, height)
   
   f.options = MovixLib_GetTable()
   f.options.name = name
   f.options.parent = p
   
   f:EnableMouse(true)
   f:SetMovable(false)
   f:SetClampedToScreen(false)
   f:SetToplevel(true)
   
   
   f.Titlebar = MovixLib_GetControlObject(f, "button", "Titlebar\nDrag to move") 
   local tb = f.Titlebar
   tb:SetNormalTexture("interface\\AddOns\\GM\\gfx\\titleBar")
   tb:SetPushedTexture("interface\\AddOns\\GM\\gfx\\titleBar")
   tb:SetDisabledTexture("interface\\AddOns\\GM\\gfx\\titleBar")
   tb:SetNormalTexture("")
   tb:SetPushedTexture("")
   tb:SetDisabledTexture("")
   tb:ClearAllPoints()
   tb:SetParent(f)
   tb:SetPoint("TOPLEFT", f, "TOPLEFT", 4,-4)
   tb:SetPoint("BOTTOMRIGHT", f, "TOPRIGHT",-4,-MovixLib_UIFrames.TitleHeight)
   tb:SetMovable(false)
   tb:SetText("")

   --tb:SetScript("OnMouseDown", function () f.StartMoving(f) end) 
   --tb:SetScript("OnMouseUp", function () f.StopMovingOrSizing(f) end) 
   tb:Disable()
   if not f.titlebarBg then f.titlebarBg = MovixLib_GetControlObject(tb, "texture") end
   local tbBg = f.titlebarBg
   tbBg:SetTexture("interface\\buttons\\greengrad64")
   tbBg:SetAlpha(0.2)
   tbBg:SetTexCoord(0,0.7,0,1)
   tbBg:SetAllPoints()
   
   if not f.titlebarLine then f.titlebarLine = MovixLib_GetControlObject(tb, "texture") end
   local tbLine = f.titlebarLine
   tbLine:SetTexture("")
   tbLine:SetVertexColor(1,1,1,1)
   tbLine:SetTexture(1,1,1,0.5)
   tbLine:SetPoint("TOPLEFT", tb, "BOTTOMLEFT",0,-1)
   tbLine:SetPoint("BOTTOMRIGHT", tb, "BOTTOMRIGHT",0,-2)

   
   if not f.PinupButton then f.PinupButton = MovixLib_GetControlObject(tb, "button") end
   local pu = f.PinupButton 
   pu:SetNormalTexture("interface/buttons/ui-panel-minimizebutton-up")
   pu:SetDisabledTexture("interface/buttons/ui-panel-minimizebutton-disabled")
   pu:SetHighlightTexture("interface/buttons/ui-panel-minimizebutton-highlight")
   pu:SetPushedTexture("interface/buttons/ui-panel-minimizebutton-down")
   pu:SetText("")
    
   pu:ClearAllPoints()
   pu:SetParent(tb)
   pu:SetPoint("TOPRIGHT", tb, "TOPRIGHT", -2, 4)
   pu:SetHeight(MovixLib_UIFrames.TitleHeight)
   pu:SetWidth(MovixLib_UIFrames.TitleHeight)
   pu:SetScript("OnClick", function() f.Hide(f) end)
   
   tb.TitleLabel = MovixLib_GetControlObject(tb, "string")
   local tl = tb.TitleLabel
   tl:SetFontObject(MovixLib_UIFrames.Titlefont)
   tl:SetAllPoints()
   tl:SetText(name)
   tl:SetJustifyH("LEFT")
   tl:SetTextColor(1,1,1,1)
   
   
   f.Content  = MovixLib_GetControlObject(f, "frame")
   local c = f.Content
   c:ClearAllPoints()
   c:SetPoint("TOPLEFT", tb, "BOTTOMLEFT", -4,0)
   c:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0,0)
   c:SetBackdrop({bgFile = "", edgeFile="", edgeSize = 0, insets = {0,0,0,0}})

   
   f:ClearAllPoints()
   f:SetWidth(width)
   f:SetHeight(height)
   f:SetParent(p)
   return f
end




function MovixLib_ShowTable(tbl, name, rotate_table)
   local frame = getglobal(name)
   local tbl_data = getglobal(tbl)
   local data = {}
   if not frame then
      frame = MovixLib_UIFrames.Create(UIParent, name, 300 , 200, 0,0, true)
      frame:SetBackdrop({bgFile = "Interface/CharacterFrame/UI-Party-Background", 
            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
            tile = true, tileSize = 16, edgeSize = 16, 
            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
      frame:SetBackdropColor(0, 0, 0, 0.5) 
      frame:ClearAllPoints()
      frame:SetPoint("CENTER", 0, 0)
      setglobal(name, frame)
   end
   frame.rotate_table = rotate_table
   if rotate_table then
      for k,v in pairs (tbl_data) do
         tinsert(data, {["FIELD"] = k, ["VALUE"] = v})       
      end
      setglobal(tbl.."_rotate", data)
      tbl = tbl .. "_rotate"
      -- else
      --      local data = getglobal(tbl)
   end
   
   
   local content = frame.Content
   if frame.Gridinit ~= true then
      MovixLib_GetGridDefaults(content, name, tbl)
      MovixLib_FillData(content);
      MovixLib_RefreshGrid(content, true, nil, true)
      frame.Gridinit = true
   else
      MovixLib_FillData(content)
      MovixLib_RefreshGrid(content)
   end
   frame:Show();
end


function MovixLib_UIFrames.Create(parent, name, width, height, pos_left, pos_top, delimeters)
   local p = MovixLib_LocateFrame(parent)
   local f  = MovixLib_GetControlObject(p, "frame", name, width, height)
   function f:Resize (w,h,l,t)     
                    MovixLib_UIFrames.Resize(self:GetParent(), self, w,h,l,t)
                end

   f.options = MovixLib_GetTable()
   f.options.name = name
   f.options.parent = p
   
   f:EnableMouse(true)
   f:SetMovable(true)
   f:SetClampedToScreen(true)
   f:SetToplevel(true)
   
   
   f.Titlebar = MovixLib_GetControlObject(f, "button", "Titlebar\nDrag to move") 
   local tb = f.Titlebar
   tb:SetNormalTexture("interface\\AddOns\\GM\\gfx\\titleBar")
   tb:SetPushedTexture("interface\\AddOns\\GM\\gfx\\titleBar")
   tb:SetDisabledTexture("interface\\AddOns\\GM\\gfx\\titleBar")
   tb:SetNormalTexture("")
   tb:SetPushedTexture("")
   tb:SetDisabledTexture("")
   tb:ClearAllPoints()
   tb:SetParent(f)
   tb:SetPoint("TOPLEFT", f, "TOPLEFT", 4,-4)
   tb:SetPoint("BOTTOMRIGHT", f, "TOPRIGHT",-4,-MovixLib_UIFrames.TitleHeight)
   tb:SetMovable(true)
   --tb:SetFrameLevel(10)
   --tb:SetFrameStrata("DIALOG")
   tb:SetScript("OnMouseDown", function () MovixLib_UIFrames.StartDrag(f) end) 
   tb:SetScript("OnMouseUp", function () MovixLib_UIFrames.StopDrag(f) end) 
   tb:Disable()
   if not f.titlebarBg then f.titlebarBg = MovixLib_GetControlObject(tb, "texture") end
   local tbBg = f.titlebarBg
   tbBg:SetTexture("interface\\buttons\\greengrad64")
   tbBg:SetAlpha(0.2)
   tbBg:SetTexCoord(0,0.7,0,1)
   tbBg:SetAllPoints()
   
   if not f.titlebarLine then f.titlebarLine = MovixLib_GetControlObject(tb, "texture") end
   local tbLine = f.titlebarLine
   tbLine:SetTexture(1,1,1,0.5)
   tbLine:SetPoint("TOPLEFT", tb, "BOTTOMLEFT",0,-1)
   tbLine:SetPoint("BOTTOMRIGHT", tb, "BOTTOMRIGHT",0,-2)
   
   --tb:SetScript("OnEnter", function () tb:SetText(name) end) 
   --tb:SetScript("OnLeave", function () tb:SetText("") end) 
   --tb:SetFrameStrata("MEDIUM")
   
   if p:GetName() ~= "UIParent" then
    if not f.PinupButton then f.PinupButton = MovixLib_GetControlObject(tb, "button", "Detach/Attach") end
    local pu = f.PinupButton 
    pu:SetNormalTexture("interface\\AddOns\\GM\\gfx\\arrow-u")
    pu:SetDisabledTexture("interface\\AddOns\\GM\\gfx\\arrow-u-d")
    pu:SetHighlightTexture("interface\\AddOns\\GM\\gfx\\arrow-u-h")
    pu:SetPushedTexture("interface\\AddOns\\GM\\gfx\\arrow-u-p")
    
    pu:ClearAllPoints()
    pu:SetParent(tb)
    pu:SetPoint("TOPRIGHT", tb, "TOPRIGHT", 0, 0)
    pu:SetHeight(MovixLib_UIFrames.TitleHeight)
    pu:SetWidth(MovixLib_UIFrames.TitleHeight)
    pu:SetScript("OnClick", function() message("ok")end)
   end
   
    if not f.CloseButton then f.CloseButton = MovixLib_GetControlObject(tb, "button", "Close") end
    local close = f.CloseButton
    close:SetNormalTexture("interface\\AddOns\\GEM3UI\\X")
    close:SetDisabledTexture("interface\\AddOns\\GEM3UI\\X")
    close:SetHighlightTexture("interface\\AddOns\\GEM3UI\\X")
    close:SetPushedTexture("interface\\AddOns\\GM\\GEM3UI\\X")

    --close:SetText("x") 
    close:ClearAllPoints()
    close:SetParent(tb)
    close:SetHeight(MovixLib_UIFrames.TitleHeight-5)
    close:SetWidth(MovixLib_UIFrames.TitleHeight)
    close:SetPoint("TOPRIGHT", tb, "TOPRIGHT", -5, 0)
    close:SetScript("OnClick", function() f.Hide(f) end)

   
   tb.TitleLabel = MovixLib_GetControlObject(tb, "string")
   local tl = tb.TitleLabel
   tl:SetFontObject(MovixLib_UIFrames.Titlefont)
   tl:SetAllPoints()
   tl:SetText(name)
   
   f.Content  = MovixLib_GetControlObject(f, "frame")
   local c = f.Content
   c:ClearAllPoints()
   c:SetPoint("TOPLEFT", tb, "BOTTOMLEFT", -4,0)
   c:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0,0)
   c:SetBackdrop({bgFile = "", edgeFile="", edgeSize = 0, insets = {0,0,0,0}})

   
   f:ClearAllPoints()
   f:Resize(width,height,pos_left,pos_top)
   tinsert(MovixLib_UIFrames.Frames, f)
   
   return f
end

function MovixLib_UIFrames.PinupButton_OnClick(self)
 
end

function MovixLib_UIFrames.StartDrag(self)
  self.StartMoving(self)
end

function MovixLib_UIFrames.StopDrag(self)
 self.StopMovingOrSizing(self)
 --local p = self:GetParent()
 self:Resize() 
 --[[ for i,d in ipairs(self.delimiters) do
   local p = d["LEFTPARENT"]
   if p then
    MovixLib_UIDelimiter.ParentAdd(d, p, "LEFT")
   end
   local p = d["RIGHTPARENT"]
   if p then
    MovixLib_UIDelimiter.ParentAdd(d, p, "RIGHT")
   end
   local p = d["TOPPARENT"]
   if p then
    MovixLib_UIDelimiter.ParentAdd(d, p, "TOP")
   end
   local p = d["BOTTOMPARENT"]
   if p then
    MovixLib_UIDelimiter.ParentAdd(d, p, "BOTTOM")
   end
   d:SetParent(self)
 end]]--
 
end

function MovixLib_UIFrames.Resize(parent, name, width, height, pos_left, pos_top)
   local point, relativeTo, relativePoint, px, py 
   local f = MovixLib_UIFrames.Get(name)
   if not f then return nil end
   local p = f.options.parent
   if parent then p = MovixLib_LocateFrame(parent) end
   local rl, rb, rw, rh = f:GetRect()
   local h = height or rh
   local w = width or rw
   local l = pos_left or rl
   --point, relativeTo, relativePoint, px, py = MovixLib_GetPoint(p, "TOP")
   local t = pos_top or p:GetHeight()-(rb+rh)
   --f:ClearAllPoints()
   f:SetParent(p)
   
   if w then   f:SetWidth(w)   end
   if h then   f:SetHeight(h)  end
   if t then f:SetPoint("TOP", p, "TOP",0, -t) end
   if t and h then f:SetPoint("BOTTOM",p, "BOTTOM",  0, p:GetHeight()-(t+h)) end
   if l then f:SetPoint("LEFT", p, "LEFT", l, 0) end
   if l and w then f:SetPoint("RIGHT", p, "RIGHT", (p:GetWidth()-l-w)*-1, 0) end
   
   
   if p:GetName() == "UIParent" then
    tdbg("SET BORDER DELIMITER FOR ", f:GetName())
    
    if not f.LD then f.LD = MovixLib_UIDelimiter.Create(f, "V", 0) end
    MovixLib_UIDelimiter.LeftParentAdd(f.LD,f)
    
    if not f.RD then f.RD = MovixLib_UIDelimiter.Create(f, "V", 0) end
    MovixLib_UIDelimiter.RightParentAdd(f.RD,f)

    if not f.TD then f.TD = MovixLib_UIDelimiter.Create(f, "H", 0, MovixLib_UIFrames.TitleHeight) end
    MovixLib_UIDelimiter.TopParentAdd(f.TD,f)
    
    if not f.BD then f.BD = MovixLib_UIDelimiter.Create(f, "H", 0) end
    MovixLib_UIDelimiter.BottomParentAdd(f.BD,f)
    
   end
   return true
end


-- delimiter
MovixLib_UIDelimiter = {}
function  MovixLib_UIDelimiter.Create(parent, orientation, pos, offset)
    
    local p = MovixLib_LocateFrame(parent)
    if not p.delimiters then p.delimiters = MovixLib_GetTable() end
    local D = p.delimiters
    local d = MovixLib_GetControlObject(p:GetName(), "frame")
    d:SetBackdrop({bgFile = "", edgeFile="", edgeSize = 0, insets = {0,0,0,0}})
    d:SetBackdropColor(1,1,1,1)
    local t = MovixLib_GetControlObject(d:GetName(), "texture")
    if not d.options then d.options = MovixLib_GetTable() end
    t:SetAllPoints()
    t:SetTexture(1,1,0,0.5)
    t:SetDrawLayer("BACKGROUND")
    d:RegisterForDrag("LeftButton")
    d:EnableMouse(true)
    d:SetMovable(true)
    
    d:SetScript("OnDragStart", function (self) MovixLib_UIFrames.DelimiterStartDrag(self) end) 
    d:SetScript("OnDragStop", function (self) MovixLib_UIFrames.DelimiterStopDrag(self) end) 
    d:SetScript("OnEnter", function(self) self:SetAlpha(1) end) 
    d:SetScript("OnLeave", function(self) self:SetAlpha(0) end) 
    d.options.orientation = orientation or "V"
    d.options.offset = offset
    d:ClearAllPoints()
    d:SetParent(p)
    d:SetAlpha(0)
    tinsert(D,d)
    if d.options.orientation == "V" then
        d:SetPoint("LEFT", p, "LEFT", pos or 0, 0)
        d:SetPoint("TOP", p, "TOP", 0 ,0)
        d:SetPoint("BOTTOM", p, "BOTTOM",0 ,0)
        d:SetWidth(5)

    else
        d:SetPoint("TOP", p, "TOP", 0, pos or 0)
        d:SetPoint("LEFT", p, "LEFT", 0, 0)
        d:SetPoint("RIGHT", p, "RIGHT", 0, 0)
        d:SetHeight(5)
    end
    --d:Show()
    
    return d
end

function  MovixLib_UIDelimiter.LeftParentAdd(self, parent)
 MovixLib_UIDelimiter.ParentAdd(self, parent, "LEFT")
end

function  MovixLib_UIDelimiter.RightParentAdd(self, parent)
 MovixLib_UIDelimiter.ParentAdd(self, parent, "RIGHT")
end

function  MovixLib_UIDelimiter.TopParentAdd(self, parent)
 MovixLib_UIDelimiter.ParentAdd(self, parent, "TOP")
end

function  MovixLib_UIDelimiter.BottomParentAdd(self, parent)
 MovixLib_UIDelimiter.ParentAdd(self, parent, "BOTTOM")
end


function  MovixLib_UIDelimiter.ParentAdd(self, parent, side)
    self:ClearAllPoints()
    if side == "BOTTOM" then
        y = -5
        x = 0
    elseif side == "TOP" then
        y = 5
        x = 0
    elseif side == "LEFT" then
        x = -5
        y = 0   
    elseif side == "RIGHT" then
        x = 5
        y = 0   
    end
    self:SetPoint(side, parent, side,x, y)
    self[side.."PARENT"] = parent
end

function  MovixLib_UIDelimiter.LeftChildAdd(self, child)
 MovixLib_UIDelimiter.ChildAdd(self, child, "LEFT")
 local fy = self:GetBottom()/UIParent:GetEffectiveScale()
 local cy = child:GetBottom()/UIParent:GetEffectiveScale()
 fy = cy-fy
 child:SetPoint("RIGHT", self, "LEFT",self.options.offset or 0, fy)
end

function  MovixLib_UIDelimiter.RightChildAdd(self, child)
 MovixLib_UIDelimiter.ChildAdd(self, child, "RIGHT")
 --local point, relativeTo, relativePoint, fx, fy = self:GetPoint(1)
 local fy = self:GetBottom()/UIParent:GetEffectiveScale()
 local cy = child:GetBottom()/UIParent:GetEffectiveScale()
 fy = cy-fy
 child:SetPoint("LEFT", self, "RIGHT",  self.options.offset or 0, fy)
end

function  MovixLib_UIDelimiter.TopChildAdd(self, child)
 MovixLib_UIDelimiter.ChildAdd(self, child, "TOP")
 local fx = self:GetLeft()/UIParent:GetEffectiveScale()
 local cx = child:GetLeft()/UIParent:GetEffectiveScale()
 fx = cx-fx
 child:SetPoint("BOTTOM", self, "TOP",fx, (self.options.offset or 0)*-1)
end

function  MovixLib_UIDelimiter.BottomChildAdd(self, child)
 MovixLib_UIDelimiter.ChildAdd(self, child, "BOTTOM")
 local fx = self:GetLeft()/UIParent:GetEffectiveScale()
 local cx = child:GetLeft()/UIParent:GetEffectiveScale()
 fx = cx-fx
 child:SetPoint("TOP", self, "BOTTOM", fx, (self.options.offset or 0)*-1)
end

function  MovixLib_UIDelimiter.ChildAdd(self, child, side)
    if not self[side.."CHILD"] then self[side.."CHILD"] = MovixLib_GetTable() end
    self[side.."CHILD"][child:GetName()] = child
end

function MovixLib_GetPoint(f, p)
    for i=1, f:GetNumPoints() do
     local point, relativeTo, relativePoint, x, y = f:GetPoint(i)
     if point == p then
      return point, relativeTo, relativePoint, x, y
     end
     
    end
    return nil
end

function MovixLib_UIDelimiter.AddAncor(V1,menu, side)


end

function  MovixLib_UIFrames.DelimiterDrag(self)
   --local self = select(1, ...);
   local x, y = GetCursorPosition();
   if getp then 
    getp(self)
   end
   local hasparent = false
   if self.options.orientation == "V" then
      local p_l = self:GetParent():GetLeft()
      nx = (x-self.x)/self:GetParent():GetEffectiveScale()      
      self.x = x
      local p = self["LEFTPARENT"]
      if p then
        self:SetPoint("LEFT", self:GetParent(), "LEFT", nx, 0);
        local point, relativeTo, relativePoint, px, py = MovixLib_GetPoint(p, "LEFT")
           if getp then 
                getp(p)
           end
        p:SetPoint("LEFT", relativeTo, relativePoint, px+nx, 0)
        hasparent = true
        self:ClearAllPoints()
        self:SetPoint("LEFT", self:GetParent(), "LEFT", 0, 0);
      end
      p = self["RIGHTPARENT"]
      if p then
        self:SetPoint("RIGHT", self:GetParent(), "RIGHT", nx, 0);
        local point, relativeTo, relativePoint, px, py = MovixLib_GetPoint(p, "RIGHT")
        
        p:SetPoint("RIGHT", relativeTo, relativePoint, px+nx, 0)
        hasparent = true
        self:ClearAllPoints()
        self:SetPoint("RIGHT", self:GetParent(), "RIGHT", 0, 0);
      end
      if not hasparent then
       local point, relativeTo, relativePoint, fx, fy = MovixLib_GetPoint(self, "LEFT")   
       self:SetPoint("LEFT", relativeTo, relativePoint, fx+nx, 0);
      end
   else
      local p_t = self:GetParent():GetTop()
      ny = (y-self.y)/self:GetParent():GetEffectiveScale()      
      self.y = y
      local p = self["TOPPARENT"]
      if p then
        self:SetPoint("TOP", self:GetParent(), "TOP", 0, y);
        local point, relativeTo, relativePoint, px, py = MovixLib_GetPoint(p, "TOP")
        p:SetPoint("TOP", relativeTo, relativePoint, 0, py+ny)
        hasparent = true
        self:ClearAllPoints()
        self:SetPoint("TOP", self:GetParent(), "TOP", 0, 0);
      end
      p = self["BOTTOMPARENT"]
      if p then
        self:SetPoint("BOTTOM", self:GetParent(), "BOTTOM", 0, y);
        local point, relativeTo, relativePoint, px, py = MovixLib_GetPoint(p, "BOTTOM")
        p:SetPoint("BOTTOM", relativeTo, relativePoint, 0, py+ny)
        hasparent = true
        self:ClearAllPoints()
        self:SetPoint("BOTTOM", self:GetParent(), "BOTTOM", 0, 0);
      end
      if not hasparent then
       local point, relativeTo, relativePoint, fx, fy = MovixLib_GetPoint(self, "TOP")   
       self:SetPoint("TOP", relativeTo, relativePoint, 0, fy+ny);
      end
   end
   --tdbg("NX ", nx, " NY", ny)
end


function MovixLib_UIFrames.DelimiterStartDrag(self)
   local x, y = GetCursorPosition();
   self.x = x--/UIParent:GetEffectiveScale() 
   self.y = y--/UIParent:GetEffectiveScale() 
   self:SetScript("OnUpdate", MovixLib_UIFrames.DelimiterDrag);
   self.framestrata=self:GetFrameStrata();
   self:SetFrameStrata("BACKGROUND");
end


function MovixLib_UIFrames.DelimiterStopDrag(self)
   self:SetScript("OnUpdate", nil);
   self:SetFrameStrata(self.framestrata);
   self:SetUserPlaced(false);
end
